package com.njcn.system.api.fallback;

import com.njcn.common.pojo.enums.response.CommonResponseEnum;
import com.njcn.common.pojo.exception.BusinessException;
import com.njcn.common.pojo.response.HttpResult;
import com.njcn.system.api.AuditFeignClient;
import com.njcn.system.utils.SystemEnumUtil;
import feign.hystrix.FallbackFactory;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;


/**
 * @author denghuajun
 * @version 1.0.0
 * @date 2022年01月05日 15:08
 */
@Slf4j
@Component
public class AuditFeignClientFallbackFactory implements FallbackFactory<AuditFeignClient> {


    @Override
    public AuditFeignClient create(Throwable cause) {
        //判断抛出异常是否为解码器抛出的业务异常
        Enum<?> exceptionEnum = CommonResponseEnum.SERVICE_FALLBACK;
        if(cause.getCause() instanceof BusinessException){
            BusinessException businessException = (BusinessException) cause.getCause();
            exceptionEnum = SystemEnumUtil.getExceptionEnum(businessException.getResult());
        }
        Enum<?> finalExceptionEnum = exceptionEnum;
        return new AuditFeignClient() {

            @Override
            public HttpResult clearHistoryLog() {
                log.error("{}异常，降级处理，异常为：{}","清空历史日志",cause.toString());
                throw new BusinessException(finalExceptionEnum);
            }
        };
    }
}
